# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []
variables = {}

# Read local variables file if available
if isfile(makepath(programfiles32,'wapt','private','symetric.txt')) and isfile(makepath(programfiles32,'wapt','private','variables.txt')):
    print('Reading local encrypted variables file')
    from cryptography.fernet import Fernet
    import yaml
    f = Fernet(bytes(open(makepath(programfiles32,'wapt','private','symetric.txt'),'r').read(), 'utf-8'))
    variables.update(yaml.safe_load(f.decrypt(bytes(open(makepath(programfiles32,'wapt','private','variables.txt'),'r').read(), 'utf-8'))))

def install():

    if 'openvpn_config' in variables:
        print('Deploying client configuration')
        open(makepath(programfiles,'OpenVPN','config','vpn.ovpn'),'w').write(variables['openvpn_config'])

    print('Disable remember password')
    registry_setstring(HKEY_LOCAL_MACHINE, r'SOFTWARE\OpenVPN', 'disable_save_passwords', 0, REG_DWORD)

    print('Auto start OpenVPN')
    create_programs_menu_shortcut('OpenVPN',target=makepath(programfiles, 'OpenVPN', 'bin', 'openvpn-gui.exe'), folder='Startup')

def uninstall():

    print('Enable password remember')
    registry_setstring(HKEY_LOCAL_MACHINE, r'SOFTWARE\OpenVPN', 'disable_save_passwords', 0, REG_DWORD)

    print('Removing auto start shortcut')
    remove_programs_menu_shortcut('OpenVPN', folder='Startup')


def audit():

    if not registry_readstring(HKEY_LOCAL_MACHINE, r'SOFTWARE\OpenVPN','disable_save_passwords'):
        print(r"key SOFTWARE\OpenVPN\disable_save_passwords doesn't exist")
        return "ERROR"
    value = registry_readstring(HKEY_LOCAL_MACHINE,  r'SOFTWARE\OpenVPN','disable_save_passwords')
    if value != 1:
        print('disable_save_passwords is not 1')

    return "OK"

if __name__ == '__main__':
    update_package()

